// Code generated by informer-gen. DO NOT EDIT.

package internalversion

import (
	time "time"

	network "github.com/openshift/origin/pkg/network/apis/network"
	internalinterfaces "github.com/openshift/origin/pkg/network/generated/informers/internalversion/internalinterfaces"
	internalclientset "github.com/openshift/origin/pkg/network/generated/internalclientset"
	internalversion "github.com/openshift/origin/pkg/network/generated/listers/network/internalversion"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	runtime "k8s.io/apimachinery/pkg/runtime"
	watch "k8s.io/apimachinery/pkg/watch"
	cache "k8s.io/client-go/tools/cache"
)

// HostSubnetInformer provides access to a shared informer and lister for
// HostSubnets.
type HostSubnetInformer interface {
	Informer() cache.SharedIndexInformer
	Lister() internalversion.HostSubnetLister
}

type hostSubnetInformer struct {
	factory          internalinterfaces.SharedInformerFactory
	tweakListOptions internalinterfaces.TweakListOptionsFunc
}

// NewHostSubnetInformer constructs a new informer for HostSubnet type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewHostSubnetInformer(client internalclientset.Interface, resyncPeriod time.Duration, indexers cache.Indexers) cache.SharedIndexInformer {
	return NewFilteredHostSubnetInformer(client, resyncPeriod, indexers, nil)
}

// NewFilteredHostSubnetInformer constructs a new informer for HostSubnet type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewFilteredHostSubnetInformer(client internalclientset.Interface, resyncPeriod time.Duration, indexers cache.Indexers, tweakListOptions internalinterfaces.TweakListOptionsFunc) cache.SharedIndexInformer {
	return cache.NewSharedIndexInformer(
		&cache.ListWatch{
			ListFunc: func(options v1.ListOptions) (runtime.Object, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.Network().HostSubnets().List(options)
			},
			WatchFunc: func(options v1.ListOptions) (watch.Interface, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.Network().HostSubnets().Watch(options)
			},
		},
		&network.HostSubnet{},
		resyncPeriod,
		indexers,
	)
}

func (f *hostSubnetInformer) defaultInformer(client internalclientset.Interface, resyncPeriod time.Duration) cache.SharedIndexInformer {
	return NewFilteredHostSubnetInformer(client, resyncPeriod, cache.Indexers{cache.NamespaceIndex: cache.MetaNamespaceIndexFunc}, f.tweakListOptions)
}

func (f *hostSubnetInformer) Informer() cache.SharedIndexInformer {
	return f.factory.InformerFor(&network.HostSubnet{}, f.defaultInformer)
}

func (f *hostSubnetInformer) Lister() internalversion.HostSubnetLister {
	return internalversion.NewHostSubnetLister(f.Informer().GetIndexer())
}
