// Code generated by informer-gen. DO NOT EDIT.

package internalversion

import (
	time "time"

	oauth "github.com/openshift/origin/pkg/oauth/apis/oauth"
	internalinterfaces "github.com/openshift/origin/pkg/oauth/generated/informers/internalversion/internalinterfaces"
	internalclientset "github.com/openshift/origin/pkg/oauth/generated/internalclientset"
	internalversion "github.com/openshift/origin/pkg/oauth/generated/listers/oauth/internalversion"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	runtime "k8s.io/apimachinery/pkg/runtime"
	watch "k8s.io/apimachinery/pkg/watch"
	cache "k8s.io/client-go/tools/cache"
)

// OAuthClientAuthorizationInformer provides access to a shared informer and lister for
// OAuthClientAuthorizations.
type OAuthClientAuthorizationInformer interface {
	Informer() cache.SharedIndexInformer
	Lister() internalversion.OAuthClientAuthorizationLister
}

type oAuthClientAuthorizationInformer struct {
	factory          internalinterfaces.SharedInformerFactory
	tweakListOptions internalinterfaces.TweakListOptionsFunc
}

// NewOAuthClientAuthorizationInformer constructs a new informer for OAuthClientAuthorization type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewOAuthClientAuthorizationInformer(client internalclientset.Interface, resyncPeriod time.Duration, indexers cache.Indexers) cache.SharedIndexInformer {
	return NewFilteredOAuthClientAuthorizationInformer(client, resyncPeriod, indexers, nil)
}

// NewFilteredOAuthClientAuthorizationInformer constructs a new informer for OAuthClientAuthorization type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewFilteredOAuthClientAuthorizationInformer(client internalclientset.Interface, resyncPeriod time.Duration, indexers cache.Indexers, tweakListOptions internalinterfaces.TweakListOptionsFunc) cache.SharedIndexInformer {
	return cache.NewSharedIndexInformer(
		&cache.ListWatch{
			ListFunc: func(options v1.ListOptions) (runtime.Object, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.Oauth().OAuthClientAuthorizations().List(options)
			},
			WatchFunc: func(options v1.ListOptions) (watch.Interface, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.Oauth().OAuthClientAuthorizations().Watch(options)
			},
		},
		&oauth.OAuthClientAuthorization{},
		resyncPeriod,
		indexers,
	)
}

func (f *oAuthClientAuthorizationInformer) defaultInformer(client internalclientset.Interface, resyncPeriod time.Duration) cache.SharedIndexInformer {
	return NewFilteredOAuthClientAuthorizationInformer(client, resyncPeriod, cache.Indexers{cache.NamespaceIndex: cache.MetaNamespaceIndexFunc}, f.tweakListOptions)
}

func (f *oAuthClientAuthorizationInformer) Informer() cache.SharedIndexInformer {
	return f.factory.InformerFor(&oauth.OAuthClientAuthorization{}, f.defaultInformer)
}

func (f *oAuthClientAuthorizationInformer) Lister() internalversion.OAuthClientAuthorizationLister {
	return internalversion.NewOAuthClientAuthorizationLister(f.Informer().GetIndexer())
}
